"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RangePicker = exports.CalendarPicker = void 0;

var _react = _interopRequireWildcard(require("react"));

var _utils = require("./utils.js");

var _locale = _interopRequireDefault(require("./locale.js"));

var _Calendar = _interopRequireDefault(require("./Calendar.js"));

var _RangeDate = _interopRequireDefault(require("./RangeDate.js"));

var _RangeTime = _interopRequireDefault(require("./RangeTime.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var DEFAULT_LACALE = 'en-us';

try {
  STYLES = {
    "react-minimal-datetime-range-calendar--range": "react-minimal-datetime-range__react-minimal-datetime-range-calendar--range",
    "react-minimal-datetime-range": "react-minimal-datetime-range__react-minimal-datetime-range",
    "visible": "react-minimal-datetime-range__visible",
    "react-minimal-datetime-range__calendar": "react-minimal-datetime-range__react-minimal-datetime-range__calendar",
    "react-minimal-datetime-range__close": "react-minimal-datetime-range__react-minimal-datetime-range__close",
    "react-minimal-datetime-range__clear": "react-minimal-datetime-range__react-minimal-datetime-range__clear",
    "react-minimal-datetime-range-dropdown": "react-minimal-datetime-range__react-minimal-datetime-range-dropdown",
    "react-minimal-datetime-range-dropdown-calendar__menu": "react-minimal-datetime-range__react-minimal-datetime-range-dropdown-calendar__menu",
    "react-minimal-datetime-range-dropdown-calendar__menu-no-effect": "react-minimal-datetime-range__react-minimal-datetime-range-dropdown-calendar__menu-no-effect",
    "react-minimal-datetime-range-dropdown-calendar__container": "react-minimal-datetime-range__react-minimal-datetime-range-dropdown-calendar__container",
    "react-minimal-datetime-range-dropdown-calendar__item": "react-minimal-datetime-range__react-minimal-datetime-range-dropdown-calendar__item",
    "react-minimal-datetime-range-dropdown-calendar__month": "react-minimal-datetime-range__react-minimal-datetime-range-dropdown-calendar__month",
    "react-minimal-datetime-range-dropdown-calendar__month-item": "react-minimal-datetime-range__react-minimal-datetime-range-dropdown-calendar__month-item",
    "active": "react-minimal-datetime-range__active",
    "react-minimal-datetime-range-calendar__previous": "react-minimal-datetime-range__react-minimal-datetime-range-calendar__previous",
    "react-minimal-datetime-range-calendar__next": "react-minimal-datetime-range__react-minimal-datetime-range-calendar__next",
    "react-minimal-datetime-range-dropdown-calendar__year": "react-minimal-datetime-range__react-minimal-datetime-range-dropdown-calendar__year",
    "react-minimal-datetime-range-dropdown-calendar__year-item": "react-minimal-datetime-range__react-minimal-datetime-range-dropdown-calendar__year-item",
    "react-minimal-datetime-range-calendar__default-day": "react-minimal-datetime-range__react-minimal-datetime-range-calendar__default-day",
    "react-minimal-datetime-range-calendar__today": "react-minimal-datetime-range__react-minimal-datetime-range-calendar__today",
    "react-minimal-datetime-range-calendar__icon": "react-minimal-datetime-range__react-minimal-datetime-range-calendar__icon",
    "react-minimal-datetime-range-calendar__clicker": "react-minimal-datetime-range__react-minimal-datetime-range-calendar__clicker",
    "react-minimal-datetime-range__col": "react-minimal-datetime-range__react-minimal-datetime-range__col",
    "react-minimal-datetime-range-calendar__title": "react-minimal-datetime-range__react-minimal-datetime-range-calendar__title",
    "react-minimal-datetime-range-calendar__inline-span": "react-minimal-datetime-range__react-minimal-datetime-range-calendar__inline-span",
    "react-minimal-datetime-range-calendar__content": "react-minimal-datetime-range__react-minimal-datetime-range-calendar__content",
    "react-minimal-datetime-range__col-0-5": "react-minimal-datetime-range__react-minimal-datetime-range__col-0-5",
    "react-minimal-datetime-range__col-9": "react-minimal-datetime-range__react-minimal-datetime-range__col-9",
    "react-minimal-datetime-range__col-3": "react-minimal-datetime-range__react-minimal-datetime-range__col-3",
    "react-minimal-datetime-range__col-6": "react-minimal-datetime-range__react-minimal-datetime-range__col-6",
    "react-minimal-datetime-range-calendar__header": "react-minimal-datetime-range__react-minimal-datetime-range-calendar__header",
    "react-minimal-datetime-range--inline-block": "react-minimal-datetime-range__react-minimal-datetime-range--inline-block",
    "react-minimal-datetime-range-calendar__table": "react-minimal-datetime-range__react-minimal-datetime-range-calendar__table",
    "react-minimal-datetime-range-calendar__table-row": "react-minimal-datetime-range__react-minimal-datetime-range-calendar__table-row",
    "react-minimal-datetime-range-calendar__table-cel": "react-minimal-datetime-range__react-minimal-datetime-range-calendar__table-cel",
    "disabled": "react-minimal-datetime-range__disabled",
    "today": "react-minimal-datetime-range__today",
    "range": "react-minimal-datetime-range__range",
    "highlight": "react-minimal-datetime-range__highlight",
    "no-border": "react-minimal-datetime-range__no-border",
    "react-minimal-datetime-range-calendar__date-item": "react-minimal-datetime-range__react-minimal-datetime-range-calendar__date-item",
    "react-minimal-datetime-range-calendar__table-caption": "react-minimal-datetime-range__react-minimal-datetime-range-calendar__table-caption",
    "react-minimal-datetime-range-calendar__mask": "react-minimal-datetime-range__react-minimal-datetime-range-calendar__mask",
    "react-minimal-datetime-range-check": "react-minimal-datetime-range__react-minimal-datetime-range-check",
    "react-minimal-datetime-range__icon-fill": "react-minimal-datetime-range__react-minimal-datetime-range__icon-fill",
    "react-minimal-datetime-range-check__path": "react-minimal-datetime-range__react-minimal-datetime-range-check__path",
    "react-minimal-datetime-range-calendar__button": "react-minimal-datetime-range__react-minimal-datetime-range-calendar__button",
    "forwardEnter": "react-minimal-datetime-range__forwardEnter",
    "forwardEnterActive": "react-minimal-datetime-range__forwardEnterActive",
    "forwardLeave": "react-minimal-datetime-range__forwardLeave",
    "forwardLeaveActive": "react-minimal-datetime-range__forwardLeaveActive",
    "backwardEnter": "react-minimal-datetime-range__backwardEnter",
    "backwardEnterActive": "react-minimal-datetime-range__backwardEnterActive",
    "backwardLeave": "react-minimal-datetime-range__backwardLeave",
    "backwardLeaveActive": "react-minimal-datetime-range__backwardLeaveActive",
    "react-minimal-datetime-range-calendar__title-container": "react-minimal-datetime-range__react-minimal-datetime-range-calendar__title-container",
    "react-minimal-datetime-range-calendar__selector-panel-year-set-container": "react-minimal-datetime-range__react-minimal-datetime-range-calendar__selector-panel-year-set-container",
    "react-minimal-datetime-range-calendar__body-container": "react-minimal-datetime-range__react-minimal-datetime-range-calendar__body-container",
    "slide": "react-minimal-datetime-range__slide",
    "slide-enter": "react-minimal-datetime-range__slide-enter",
    "slide-enter-active": "react-minimal-datetime-range__slide-enter-active",
    "slide-leave": "react-minimal-datetime-range__slide-leave",
    "slide-leave-active": "react-minimal-datetime-range__slide-leave-active",
    "forward-enter": "react-minimal-datetime-range__forward-enter",
    "forward-enter-active": "react-minimal-datetime-range__forward-enter-active",
    "forward-leave": "react-minimal-datetime-range__forward-leave",
    "forward-leave-active": "react-minimal-datetime-range__forward-leave-active",
    "backward-enter": "react-minimal-datetime-range__backward-enter",
    "backward-enter-active": "react-minimal-datetime-range__backward-enter-active",
    "backward-leave": "react-minimal-datetime-range__backward-leave",
    "backward-leave-active": "react-minimal-datetime-range__backward-leave-active",
    "react-minimal-datetime-range__range-input-wrapper": "react-minimal-datetime-range__react-minimal-datetime-range__range-input-wrapper",
    "react-minimal-datetime-range__range-input": "react-minimal-datetime-range__react-minimal-datetime-range__range-input",
    "react-minimal-datetime-range__range-input-separator": "react-minimal-datetime-range__react-minimal-datetime-range__range-input-separator",
    "react-minimal-datetime-range__range": "react-minimal-datetime-range__react-minimal-datetime-range__range",
    "react-minimal-datetime-range__button-wrapper": "react-minimal-datetime-range__react-minimal-datetime-range__button-wrapper",
    "react-minimal-datetime-range__button": "react-minimal-datetime-range__react-minimal-datetime-range__button",
    "react-minimal-datetime-range__button--type": "react-minimal-datetime-range__react-minimal-datetime-range__button--type",
    "react-minimal-datetime-range__button--confirm": "react-minimal-datetime-range__react-minimal-datetime-range__button--confirm",
    "react-minimal-datetime-date-piker": "react-minimal-datetime-range__react-minimal-datetime-date-piker",
    "react-minimal-datetime-range__time-piker": "react-minimal-datetime-range__react-minimal-datetime-range__time-piker",
    "react-minimal-datetime-range__time-select-wrapper": "react-minimal-datetime-range__react-minimal-datetime-range__time-select-wrapper",
    "react-minimal-datetime-range__date": "react-minimal-datetime-range__react-minimal-datetime-range__date",
    "react-minimal-datetime-range__time-select-options-wrapper": "react-minimal-datetime-range__react-minimal-datetime-range__time-select-options-wrapper",
    "react-minimal-datetime-range__time-select-option": "react-minimal-datetime-range__react-minimal-datetime-range__time-select-option"
  };
} catch (ex) {}

var CalendarPicker = (0, _react.memo)(function (_ref) {
  var _ref$locale = _ref.locale,
      locale = _ref$locale === void 0 ? DEFAULT_LACALE : _ref$locale,
      _ref$show = _ref.show,
      show = _ref$show === void 0 ? false : _ref$show,
      _ref$onClose = _ref.onClose,
      onClose = _ref$onClose === void 0 ? function () {} : _ref$onClose,
      _ref$defaultDate = _ref.defaultDate,
      defaultDate = _ref$defaultDate === void 0 ? '' : _ref$defaultDate,
      _ref$onYearPicked = _ref.onYearPicked,
      onYearPicked = _ref$onYearPicked === void 0 ? function () {} : _ref$onYearPicked,
      _ref$onMonthPicked = _ref.onMonthPicked,
      onMonthPicked = _ref$onMonthPicked === void 0 ? function () {} : _ref$onMonthPicked,
      _ref$onDatePicked = _ref.onDatePicked,
      onDatePicked = _ref$onDatePicked === void 0 ? function () {} : _ref$onDatePicked,
      _ref$onResetDate = _ref.onResetDate,
      onResetDate = _ref$onResetDate === void 0 ? function () {} : _ref$onResetDate,
      _ref$onResetDefaultDa = _ref.onResetDefaultDate,
      onResetDefaultDate = _ref$onResetDefaultDa === void 0 ? function () {} : _ref$onResetDefaultDa,
      _ref$style = _ref.style,
      style = _ref$style === void 0 ? {} : _ref$style;

  var _useState = (0, _react.useState)(show),
      _useState2 = _slicedToArray(_useState, 2),
      internalShow = _useState2[0],
      setInternalShow = _useState2[1];

  var handleOnClose = (0, _react.useCallback)(function () {
    setInternalShow(false);
    onClose && onClose();
  }, []);
  var handleOnYearPicked = (0, _react.useCallback)(function (yearObj) {
    onYearPicked && onYearPicked(yearObj);
  }, []);
  var handleOnMonthPicked = (0, _react.useCallback)(function (monthObj) {
    onMonthPicked && onMonthPicked(monthObj);
  }, []);
  var handleOnDatePicked = (0, _react.useCallback)(function (dateObj) {
    onDatePicked && onDatePicked(dateObj);
  }, []);
  var handleOnResetDate = (0, _react.useCallback)(function (dateObj) {
    onResetDate && onResetDate(dateObj);
  }, []);
  var handleOnResetDefaultDate = (0, _react.useCallback)(function (dateObj) {
    onResetDefaultDate && onResetDefaultDate(dateObj);
  }, []);
  (0, _react.useEffect)(function () {
    setInternalShow(show);
  }, [show]);
  return _react["default"].createElement("div", {
    style: style
  }, internalShow && _react["default"].createElement(CalendarPickerComponent, {
    show: internalShow,
    defaultDate: defaultDate,
    locale: locale,
    onClose: handleOnClose,
    handleOnYearPicked: handleOnYearPicked,
    handleOnMonthPicked: handleOnMonthPicked,
    handleOnDatePicked: handleOnDatePicked,
    handleOnResetDate: handleOnResetDate,
    handleOnResetDefaultDate: handleOnResetDefaultDate
  }));
});
exports.CalendarPicker = CalendarPicker;
var CalendarPickerComponent = (0, _react.memo)(function (_ref2) {
  var show = _ref2.show,
      defaultDate = _ref2.defaultDate,
      locale = _ref2.locale,
      onClose = _ref2.onClose,
      handleOnYearPicked = _ref2.handleOnYearPicked,
      handleOnMonthPicked = _ref2.handleOnMonthPicked,
      handleOnDatePicked = _ref2.handleOnDatePicked,
      handleOnResetDate = _ref2.handleOnResetDate,
      handleOnResetDefaultDate = _ref2.handleOnResetDefaultDate;

  var _useState3 = (0, _react.useState)(false),
      _useState4 = _slicedToArray(_useState3, 2),
      internalShow = _useState4[0],
      setInternalShow = _useState4[1];

  var handleOnClose = (0, _react.useCallback)(function () {
    setInternalShow(false);
    onClose && onClose();
  }, []);
  (0, _react.useEffect)(function () {
    if (show) {
      setTimeout(function () {
        setInternalShow(true);
      }, 0);
    }
  }, [show]);
  var componentClass = (0, _react.useMemo)(function () {
    return (0, _utils.cx)('react-minimal-datetime-range', internalShow && 'visible');
  }, [internalShow]);
  return _react["default"].createElement("div", {
    className: componentClass
  }, _react["default"].createElement("svg", {
    className: "react-minimal-datetime-range__close",
    viewBox: "0 0 20 20",
    width: "15",
    height: "15",
    onClick: handleOnClose
  }, _react["default"].createElement("path", {
    d: "M10.185,1.417c-4.741,0-8.583,3.842-8.583,8.583c0,4.74,3.842,8.582,8.583,8.582S18.768,14.74,18.768,10C18.768,5.259,14.926,1.417,10.185,1.417 M10.185,17.68c-4.235,0-7.679-3.445-7.679-7.68c0-4.235,3.444-7.679,7.679-7.679S17.864,5.765,17.864,10C17.864,14.234,14.42,17.68,10.185,17.68 M10.824,10l2.842-2.844c0.178-0.176,0.178-0.46,0-0.637c-0.177-0.178-0.461-0.178-0.637,0l-2.844,2.841L7.341,6.52c-0.176-0.178-0.46-0.178-0.637,0c-0.178,0.176-0.178,0.461,0,0.637L9.546,10l-2.841,2.844c-0.178,0.176-0.178,0.461,0,0.637c0.178,0.178,0.459,0.178,0.637,0l2.844-2.841l2.844,2.841c0.178,0.178,0.459,0.178,0.637,0c0.178-0.176,0.178-0.461,0-0.637L10.824,10z"
  })), _react["default"].createElement("div", {
    className: "react-minimal-datetime-range__calendar"
  }, _react["default"].createElement(_Calendar["default"], {
    defaultDate: defaultDate,
    locale: locale,
    onYearPicked: handleOnYearPicked,
    onMonthPicked: handleOnMonthPicked,
    onDatePicked: handleOnDatePicked,
    onResetDate: handleOnResetDate,
    onResetDefaultDate: handleOnResetDefaultDate
  })));
});
var TYPES = ['date', 'time'];
var RangePicker = (0, _react.memo)(function (_ref3) {
  var _ref3$locale = _ref3.locale,
      locale = _ref3$locale === void 0 ? DEFAULT_LACALE : _ref3$locale,
      _ref3$placeholder = _ref3.placeholder,
      placeholder = _ref3$placeholder === void 0 ? ['', ''] : _ref3$placeholder,
      _ref3$defaultDates = _ref3.defaultDates,
      defaultDates = _ref3$defaultDates === void 0 ? ['', ''] : _ref3$defaultDates,
      _ref3$defaultTimes = _ref3.defaultTimes,
      defaultTimes = _ref3$defaultTimes === void 0 ? ['', ''] : _ref3$defaultTimes,
      _ref3$show = _ref3.show,
      show = _ref3$show === void 0 ? false : _ref3$show,
      _ref3$onConfirm = _ref3.onConfirm,
      onConfirm = _ref3$onConfirm === void 0 ? function () {} : _ref3$onConfirm,
      _ref3$onClear = _ref3.onClear,
      onClear = _ref3$onClear === void 0 ? function () {} : _ref3$onClear,
      _ref3$onClose = _ref3.onClose,
      onClose = _ref3$onClose === void 0 ? function () {} : _ref3$onClose,
      _ref3$style = _ref3.style,
      style = _ref3$style === void 0 ? {} : _ref3$style;
  // ['YYYY-MM-DD', 'YYYY-MM-DD'] // ['hh:mm', 'hh:mm']
  var isDefaultDatesValid = (0, _react.useMemo)(function () {
    var isValid = false;

    if (defaultDates.length === 2) {
      isValid = true;
      defaultDates.forEach(function (defaultDate) {
        if (!(0, _utils.isValidDate)(defaultDate)) {
          isValid = false;
        }
      });
    }

    return isValid;
  }, [defaultDates]);

  var _useState5 = (0, _react.useState)(isDefaultDatesValid ? true : false),
      _useState6 = _slicedToArray(_useState5, 2),
      selected = _useState6[0],
      setSelected = _useState6[1];

  var _useState7 = (0, _react.useState)(defaultDates[0] ? "".concat(defaultDates[0], " ").concat(defaultTimes[0] ? defaultTimes[0] : '') : ''),
      _useState8 = _slicedToArray(_useState7, 2),
      start = _useState8[0],
      setStart = _useState8[1];

  var _useState9 = (0, _react.useState)(defaultDates[1] ? "".concat(defaultDates[1], " ").concat(defaultTimes[1] ? defaultTimes[1] : '') : ''),
      _useState10 = _slicedToArray(_useState9, 2),
      end = _useState10[0],
      setEnd = _useState10[1];

  var _useState11 = (0, _react.useState)(TYPES[0]),
      _useState12 = _slicedToArray(_useState11, 2),
      type = _useState12[0],
      setType = _useState12[1];

  var _useState13 = (0, _react.useState)(show),
      _useState14 = _slicedToArray(_useState13, 2),
      internalShow = _useState14[0],
      setInternalShow = _useState14[1];

  var _useState15 = (0, _react.useState)(defaultDates[0] ? defaultDates[0].split('-') : []),
      _useState16 = _slicedToArray(_useState15, 2),
      startDatePickedArray = _useState16[0],
      setStartDatePickedArray = _useState16[1];

  var _useState17 = (0, _react.useState)(defaultDates[1] ? defaultDates[1].split('-') : []),
      _useState18 = _slicedToArray(_useState17, 2),
      endDatePickedArray = _useState18[0],
      setEndDatePickedArray = _useState18[1];

  var _useState19 = (0, _react.useState)({}),
      _useState20 = _slicedToArray(_useState19, 2),
      currentDateObjStart = _useState20[0],
      setCurrentDateObjStart = _useState20[1];

  var _useState21 = (0, _react.useState)({}),
      _useState22 = _slicedToArray(_useState21, 2),
      currentDateObjEnd = _useState22[0],
      setCurrentDateObjEnd = _useState22[1];

  var _useState23 = (0, _react.useState)(['00', '00']),
      _useState24 = _slicedToArray(_useState23, 2),
      startTimePickedArray = _useState24[0],
      setStartTimePickedArray = _useState24[1];

  var _useState25 = (0, _react.useState)(['00', '00']),
      _useState26 = _slicedToArray(_useState25, 2),
      endTimePickedArray = _useState26[0],
      setEndTimePickedArray = _useState26[1];

  var _useState27 = (0, _react.useState)(defaultDates),
      _useState28 = _slicedToArray(_useState27, 2),
      dates = _useState28[0],
      setDates = _useState28[1];

  var _useState29 = (0, _react.useState)(defaultTimes),
      _useState30 = _slicedToArray(_useState29, 2),
      times = _useState30[0],
      setTimes = _useState30[1];

  var handleChooseStartDate = (0, _react.useCallback)(function (_ref4) {
    var name = _ref4.name,
        month = _ref4.month,
        year = _ref4.year,
        value = _ref4.value;
    setDates([value, dates[1]]);
    setStartDatePickedArray(value === '' ? [] : [year, month, name]);
  }, [dates]);
  var handleChooseEndDate = (0, _react.useCallback)(function (_ref5) {
    var name = _ref5.name,
        month = _ref5.month,
        year = _ref5.year,
        value = _ref5.value;
    setDates([dates[0], value]);
    setEndDatePickedArray(value === '' ? [] : [year, month, name]);
  }, [dates]);
  var handleChooseStartTimeHour = (0, _react.useCallback)(function (res) {
    setStartTimePickedArray([res, startTimePickedArray[1]]);
  }, [startTimePickedArray]);
  var handleChooseStartTimeMinute = (0, _react.useCallback)(function (res) {
    setStartTimePickedArray([startTimePickedArray[0], res]);
  }, [startTimePickedArray]);
  var handleChooseEndTimeHour = (0, _react.useCallback)(function (res) {
    setEndTimePickedArray([res, endTimePickedArray[1]]);
  }, [endTimePickedArray]);
  var handleChooseEndTimeMinute = (0, _react.useCallback)(function (res) {
    setEndTimePickedArray([endTimePickedArray[0], res]);
  }, [endTimePickedArray]);
  var handleOnChangeType = (0, _react.useCallback)(function () {
    if (type === TYPES[0]) {
      setType(TYPES[1]);
    } else {
      setType(TYPES[0]);
    }
  }, [type]);
  var handleOnConfirm = (0, _react.useCallback)(function () {
    var a = new Date(startDatePickedArray.join('-'));
    var b = new Date(endDatePickedArray.join('-'));
    var starts = a < b ? startDatePickedArray : endDatePickedArray;
    var ends = a > b ? startDatePickedArray : endDatePickedArray;
    var startStr = "".concat(starts.join('-'), " ").concat(startTimePickedArray.join(':'));
    var endStr = "".concat(ends.join('-'), " ").concat(endTimePickedArray.join(':'));
    setStart(startStr);
    setEnd(endStr);
    setStartDatePickedArray(starts);
    setEndDatePickedArray(ends);
    setDates([starts.join('-'), ends.join('-')]);
    setInternalShow(false);
    onConfirm && onConfirm([startStr, endStr]);
  }, [startDatePickedArray, endDatePickedArray, startTimePickedArray, endTimePickedArray]);
  var handleOnClear = (0, _react.useCallback)(function (e) {
    e.stopPropagation();
    setSelected(false);
    setInternalShow(false);
    setStart('');
    setEnd('');
    setStartDatePickedArray([]);
    setEndDatePickedArray([]);
    setDates(['', '']);
    setTimes(['', '']);
    setStartTimePickedArray(['00', '00']);
    setEndTimePickedArray(['00', '00']);
    onClear && onClear();
  }, []);
  (0, _react.useEffect)(function () {
    setType(TYPES[0]);
  }, [internalShow]);
  (0, _react.useEffect)(function () {
    if (!internalShow) {
      onClose && onClose();
    }
  }, [internalShow]);
  return _react["default"].createElement("div", {
    className: "react-minimal-datetime-range__range",
    style: style
  }, _react["default"].createElement("span", {
    className: "react-minimal-datetime-range__range-input-wrapper",
    onClick: function onClick() {
      return setInternalShow(!internalShow);
    }
  }, _react["default"].createElement("input", {
    readOnly: true,
    placeholder: placeholder[0],
    className: "react-minimal-datetime-range__range-input",
    tabIndex: "-1",
    value: start
  }), _react["default"].createElement("span", {
    className: "react-minimal-datetime-range__range-input-separator"
  }, " ~ "), _react["default"].createElement("input", {
    readOnly: true,
    placeholder: placeholder[1],
    className: "react-minimal-datetime-range__range-input",
    tabIndex: "-1",
    value: end
  }), start ? _react["default"].createElement("svg", {
    className: "react-minimal-datetime-range__clear",
    width: "15",
    height: "15",
    viewBox: "0 0 24 24",
    onClick: handleOnClear
  }, _react["default"].createElement("path", {
    className: "react-minimal-datetime-range__icon-fill",
    d: "M12 2C6.47 2 2 6.47 2 12s4.47 10 10 10 10-4.47 10-10S17.53 2 12 2zm5 13.59L15.59 17 12 13.41 8.41 17 7 15.59 10.59 12 7 8.41 8.41 7 12 10.59 15.59 7 17 8.41 13.41 12 17 15.59z"
  }), _react["default"].createElement("path", {
    d: "M0 0h24v24H0z",
    fill: "none"
  })) : _react["default"].createElement("svg", {
    className: "react-minimal-datetime-range__clear",
    width: "15",
    height: "15",
    viewBox: "0 0 24 24"
  }, _react["default"].createElement("path", {
    className: "react-minimal-datetime-range__icon-fill",
    d: "M9 11H7v2h2v-2zm4 0h-2v2h2v-2zm4 0h-2v2h2v-2zm2-7h-1V2h-2v2H8V2H6v2H5c-1.11 0-1.99.9-1.99 2L3 20c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm0 16H5V9h14v11z"
  }), _react["default"].createElement("path", {
    fill: "none",
    d: "M0 0h24v24H0z"
  }))), internalShow && _react["default"].createElement(RangePickerComponent, {
    show: internalShow,
    selected: selected,
    setSelected: setSelected,
    handleChooseStartDate: handleChooseStartDate,
    handleChooseEndDate: handleChooseEndDate,
    dates: dates,
    times: times,
    locale: locale,
    startDatePickedArray: startDatePickedArray,
    endDatePickedArray: endDatePickedArray,
    type: type,
    handleOnChangeType: handleOnChangeType,
    handleOnConfirm: handleOnConfirm,
    startTimePickedArray: startTimePickedArray,
    endTimePickedArray: endTimePickedArray,
    handleChooseStartTimeHour: handleChooseStartTimeHour,
    handleChooseStartTimeMinute: handleChooseStartTimeMinute,
    handleChooseEndTimeHour: handleChooseEndTimeHour,
    handleChooseEndTimeMinute: handleChooseEndTimeMinute,
    currentDateObjStart: currentDateObjStart,
    setCurrentDateObjStart: setCurrentDateObjStart,
    currentDateObjEnd: currentDateObjEnd,
    setCurrentDateObjEnd: setCurrentDateObjEnd
  }));
});
exports.RangePicker = RangePicker;
var RangePickerComponent = (0, _react.memo)(function (_ref6) {
  var show = _ref6.show,
      selected = _ref6.selected,
      setSelected = _ref6.setSelected,
      handleChooseStartDate = _ref6.handleChooseStartDate,
      handleChooseEndDate = _ref6.handleChooseEndDate,
      dates = _ref6.dates,
      times = _ref6.times,
      locale = _ref6.locale,
      startDatePickedArray = _ref6.startDatePickedArray,
      endDatePickedArray = _ref6.endDatePickedArray,
      type = _ref6.type,
      handleOnChangeType = _ref6.handleOnChangeType,
      handleOnConfirm = _ref6.handleOnConfirm,
      handleChooseStartTimeHour = _ref6.handleChooseStartTimeHour,
      handleChooseStartTimeMinute = _ref6.handleChooseStartTimeMinute,
      handleChooseEndTimeHour = _ref6.handleChooseEndTimeHour,
      handleChooseEndTimeMinute = _ref6.handleChooseEndTimeMinute,
      startTimePickedArray = _ref6.startTimePickedArray,
      endTimePickedArray = _ref6.endTimePickedArray,
      currentDateObjList = _ref6.currentDateObjList,
      currentDateObjStart = _ref6.currentDateObjStart,
      setCurrentDateObjStart = _ref6.setCurrentDateObjStart,
      currentDateObjEnd = _ref6.currentDateObjEnd,
      setCurrentDateObjEnd = _ref6.setCurrentDateObjEnd;

  var _useState31 = (0, _react.useState)(false),
      _useState32 = _slicedToArray(_useState31, 2),
      internalShow = _useState32[0],
      setInternalShow = _useState32[1];

  (0, _react.useEffect)(function () {
    if (show) {
      setTimeout(function () {
        setInternalShow(true);
      }, 0);
    }
  }, [show]);
  var componentClass = (0, _react.useMemo)(function () {
    return (0, _utils.cx)('react-minimal-datetime-range', internalShow && 'visible');
  }, [internalShow]);
  return _react["default"].createElement("div", {
    className: componentClass
  }, _react["default"].createElement("div", {
    className: "react-minimal-datetime-date-piker"
  }, _react["default"].createElement(_RangeDate["default"], {
    selected: selected,
    setSelected: setSelected,
    handleChooseStartDate: handleChooseStartDate,
    handleChooseEndDate: handleChooseEndDate,
    rangeDirection: "start",
    defaultDateStart: dates[0],
    defaultDateEnd: dates[1],
    locale: locale,
    startDatePickedArray: startDatePickedArray,
    endDatePickedArray: endDatePickedArray,
    currentDateObjStart: currentDateObjStart,
    setCurrentDateObjStart: setCurrentDateObjStart,
    currentDateObjEnd: currentDateObjEnd,
    setCurrentDateObjEnd: setCurrentDateObjEnd
  }), _react["default"].createElement(_RangeDate["default"], {
    selected: selected,
    setSelected: setSelected,
    handleChooseStartDate: handleChooseStartDate,
    handleChooseEndDate: handleChooseEndDate,
    rangeDirection: "end",
    defaultDateStart: dates[0],
    defaultDateEnd: dates[1],
    locale: locale,
    startDatePickedArray: startDatePickedArray,
    endDatePickedArray: endDatePickedArray,
    currentDateObjStart: currentDateObjStart,
    setCurrentDateObjStart: setCurrentDateObjStart,
    currentDateObjEnd: currentDateObjEnd,
    setCurrentDateObjEnd: setCurrentDateObjEnd
  }), type === TYPES[1] && _react["default"].createElement("div", {
    className: "react-minimal-datetime-range__time-piker"
  }, _react["default"].createElement(_RangeTime["default"], {
    defaultTimeStart: times[0],
    defaultTimeEnd: times[1],
    startDatePickedArray: startDatePickedArray,
    endDatePickedArray: endDatePickedArray,
    handleChooseStartTimeHour: handleChooseStartTimeHour,
    handleChooseStartTimeMinute: handleChooseStartTimeMinute,
    handleChooseEndTimeHour: handleChooseEndTimeHour,
    handleChooseEndTimeMinute: handleChooseEndTimeMinute,
    startTimePickedArray: startTimePickedArray,
    endTimePickedArray: endTimePickedArray
  }))), _react["default"].createElement("div", {
    className: "react-minimal-datetime-range__button-wrapper"
  }, _react["default"].createElement("div", {
    className: (0, _utils.cx)('react-minimal-datetime-range__button', 'react-minimal-datetime-range__button--type', !selected && 'disabled'),
    onClick: selected ? handleOnChangeType : function () {}
  }, type === TYPES[0] ? _locale["default"][locale][TYPES[1]] : _locale["default"][locale][TYPES[0]]), _react["default"].createElement("div", {
    className: (0, _utils.cx)('react-minimal-datetime-range__button', 'react-minimal-datetime-range__button--confirm', !selected && 'disabled'),
    onClick: selected ? handleOnConfirm : function () {}
  }, _locale["default"][locale]['confirm'])));
});